1. 两数之和 Java版

LeetCode 1. 两数之和

Posted by Twany on July 15, 2019

问题描述:

给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。

你可以假设每种输入只会对应一个答案。但是,你不能重复利用这个数组中同样的元素。

示例:

1
2
3
4
给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

思路

以第一个元素2为例:

  • 取得2,将 target减去2

  • 把结果和2之后的元素进行对比
  • 若相同,则代表就是要寻找的元素,返回对应下表

解答

第一次

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
class Solution {
    public int[] twoSum(int[] nums, int target) {
        int[] arr = new int[2];
        for(int i = 0; i < nums.length; i++){
            for(int j = i + 1; j < nums.length; j++){
                if(nums[j] == target - nums[i]){
                    arr[0] = i;
                    arr[1] = j;
                }
            }
        }
        return arr;
        
    }
    throw new IllegalArgumentException("No two sum solution");
}

第二次

利用哈希表,将差结果进行对比

1
2
3
4
5
6
7
8
9
10
11
12
13
class Solution {
    public int[] twoSum(int[] nums, int target) {
        Map<Integer, Integer> map = new HashMap<>();
        for (int i = 0; i < nums.length; i++) {
            int complement = target - nums[i];
            if (map.containsKey(complement)) {
                return new int[] { map.get(complement), i };
            }
            map.put(nums[i], i);
        }
        throw new IllegalArgumentException("No two sum solution");
    }
}

总结

有上述两种方法我们可以看出,哈希表是非常快的,比逐个查找效率高太多。